#!/usr/bin/python

# allows you to write some code that will be butchered and then reassembled
# by a code generator in a relatively contiguous fashion.
# 
import sys
import re
import os.path
import cStringIO

class stkitem:
    def __init__(self, name):
        self.name = name
        self.lines = []

reinclude = re.compile(r'\s*#!include\s*"([^\"]+)"')

def processline(fout, line):
    global reinclude
    mo = reinclude.match(line)
    if mo:
        f = open(mo.group(1), 'r')
        for l in f:
            processline(fout, l)
    else:
        fout.write(line)

def rewritefile(fname, foutname, fskelname):
    f = open(fname, 'r')
    sout = cStringIO.StringIO()
    for line in f:
        processline(sout, line)
    fout = open(foutname, 'wb')
    fskel = open(fskelname, 'wb')
    fout.write("static char skstr[] = {")
    s = sout.getvalue()
    fskel.write(s)
    pos = 0
    for c in s:
        if not (pos % 30):
            fout.write('\n')
        c2 = ord(c) % 255
        fout.write("%d," % c2)
        pos += 1
    fout.write("0};\n")
    

rewritefile('c_parser.h.in', 'c_parser_out.h', 'c_parser_out.skel')
